------------------------------------------------------------------------------------------------------------------------
-- TurntableG GUI Callback Functions --------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------
-- Build a table to hold default values
  local defaultTable = {}




-- Save default values into default file
function defaultSaveCallback(component, event)
  
	-- Find script directory
 
		local scriptDir = octane.file.getSpecialDirectories()["userHomeDirectory"]
  
		filename = scriptDir.."/Walkthrough_Settings.txt"


	-- Store default values in table
	defaultTable["targetSlider"]			= 	targetSlider:getProperties().value
	defaultTable["sldCameraOrbitLeftRight"]		=	sldCameraOrbitLeftRight:getProperties().value
	defaultTable["sldCameraOrbitUpDown"]		=	sldCameraOrbitUpDown:getProperties().value
	defaultTable["sldCameraPanLeftRight"]		=	sldCameraPanLeftRight:getProperties().value
	defaultTable["sldCameraPanUpDown"]		=	sldCameraPanUpDown:getProperties().value
	defaultTable["sldCameraFowardBack"]		=	sldCameraFowardBack:getProperties().value
	defaultTable["sldMotionBlurExposure"]		=	sldMotionBlurExposure:getProperties().value
	defaultTable["sldStartAngleOffset"]		= 	sldStartAngleOffset:getProperties().value
	defaultTable["sldTargetUpDown"]		=	sldTargetUpDown:getProperties().value
	defaultTable["sldTargetLeftRight"]		=	sldTargetLeftRight:getProperties().value

	defaultTable["sldFieldOfView"]			=	sldFieldOfView:getProperties().value
	defaultTable["sldNearClipDepth"] 		=	sldNearClipDepth:getProperties().value
	defaultTable["targetSlider"]			=	targetSlider:getProperties().value

	defaultTable["sldSolarStartHour"]		=	sldSolarStartHour:getProperties().value
  	defaultTable["sldSolarEndHour"]		=	sldSolarEndHour:getProperties().value

	defaultTable["sldPreview"] 			= 	sldPreview:getProperties().value

	defaultTable["sldNumberOfFrames"]		=	sldNumberOfFrames:getProperties().value
	defaultTable["sldDuration"] 			= 	sldDuration:getProperties().value
	defaultTable["sldFrameRate"]			=	sldFrameRate:getProperties().value
	defaultTable["sldSamples"] 			= 	sldSamples:getProperties().value


	-- Save table to defaults file
  
	--local filename = "Walkthrough_Settings"
  
		saveTable(defaultTable, filename)

end



-- Load default values from default file
function defaultLoadCallback(component, event)

	-- Find script directory
	local scriptDir = octane.file.getSpecialDirectories()["userHomeDirectory"]
	filename = scriptDir.."/Walkthrough_Settings.txt"
 
	defaultTable = loadTable(filename)

	targetSlider:updateProperties 			{ value = defaultTable["targetSlider"] }
	sldCameraOrbitLeftRight:updateProperties  		{ value = defaultTable["sldCameraOrbitLeftRight"] }
	sldCameraOrbitUpDown:updateProperties 		{ value = defaultTable["sldCameraOrbitUpDown"] }
	sldCameraPanLeftRight:updateProperties 		{ value = defaultTable["sldCameraPanLeftRight"] }
	sldCameraPanUpDown:updateProperties 		{ value = defaultTable["sldCameraPanUpDown"] }
	sldCameraFowardBack:updateProperties 		{ value = defaultTable["sldCameraFowardBack"] }
	sldMotionBlurExposure:updateProperties 		{ value = defaultTable["sldMotionBlurExposure"] }
	sldStartAngleOffset:updateProperties 			{ value = defaultTable["sldStartAngleOffset"] }
	sldTargetUpDown:updateProperties 			{ value = defaultTable["sldTargetUpDown"] }
	sldTargetLeftRight:updateProperties 			{ value = defaultTable["sldTargetLeftRight"] }

	sldFieldOfView:updateProperties 			{ value =defaultTable["sldFieldOfView"]}			
	sldNearClipDepth:updateProperties 			{ value =defaultTable["sldNearClipDepth"]}	
	targetSlider:updateProperties 			{ value =defaultTable["targetSlider"]}

	sldSolarStartHour:updateProperties			{ value = defaultTable["sldSolarStartHour"] }
	sldSolarEndHour:updateProperties  			{ value = defaultTable["sldSolarEndHour"] }

	sldPreview:updateProperties  			{ value = defaultTable["sldPreview"] }

	sldSamples:updateProperties			{ value = defaultTable["sldSamples"] }
	sldDuration:updateProperties			{ value = defaultTable["sldDuration"] }
	sldFrameRate:updateProperties			{ value = defaultTable["sldFrameRate"] }
	sldNumberOfFrames:updateProperties				{ value = defaultTable["sldNumberOfFrames"] }
	sldDuration:updateProperties			{ value = defaultTable["sldDuration"] }

end


-- Reset default values
function defaultResetCallback(component, event)


	sldCameraOrbitLeftRight:updateProperties{ value = 0 }
	sldCameraOrbitUpDown:updateProperties{ value = 0 }
	sldCameraPanLeftRight:updateProperties{ value = 0 }
	sldCameraPanUpDown:updateProperties{ value = 0 }
	sldCameraFowardBack:updateProperties{ value = 0 }
	sldMotionBlurExposure:updateProperties{ value = 0 }
	sldStartAngleOffset:updateProperties{ value = 0 }
	sldTargetUpDown:updateProperties{ value = 0 }
	sldTargetLeftRight:updateProperties{ value = 0 }


	sldFieldOfView:updateProperties{ value = 45 }
	sldNearClipDepth:updateProperties{ value = tonumber(lblNearClipDepth.text)}	
	targetSlider:updateProperties{ value = 0 }

	sldSolarStartHour:updateProperties{ value = 7 }
	sldSolarEndHour:updateProperties{ value = 7 }

	sldPreview:updateProperties{ value = 1 }

	sldNumberOfFrames:updateProperties{ value = 125 }
	sldDuration:updateProperties{ value = 5 }
	sldFrameRate:updateProperties{ value = 25 }
	sldSamples:updateProperties{ value = 50 }


end


-- A render target has been choosen in the drop down, now 
-- see if it matches the current selected target node.  If they match then do nothing.  
--If they do not match then set RT_NODE and CAM_NODE to new nodes.
function targetDropDownCallback(component, event)


	if renderTarget ~= "" and RT_NODE:getProperties().name ~= renderTarget then

        
		-- find the index of the choosen render target node
        
		local index = -1


		for i, item in ipairs(octane.nodegraph.getRootGraph():getOwnedItems()) do


			if item:getProperties().name == renderTarget then
                
				index = i
                
				break
            
			end


		end

   
		newCopies = SCENE_GRAPH:copyFrom(octane.nodegraph.getRootGraph():getOwnedItems())
        
		RT_NODE = newCopies[index]
        
		CAM_NODE = RT_NODE:getConnectedNode(octane.P_CAMERA)


		-- re-initialize the UI
        
		initGui(CAM_NODE)
    
	end

end
