------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Walkthrough gui script -----------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


-- Create UI controls (labels & sliders)
-----------------------------------------------------------------------------------------
-- Create buttons for Saved Settings

	defaultLoadButton 	= ui.createButton("defaultload", "Load last saved", 162, 24, "Load the last saved settings from the file.")
	defaultSaveButton 	= ui.createButton("defaultsave", "Save", 162, 24, "Save the current settings to the settings file.")
	defaultResetButton 	= ui.createButton("defaultsave", "Reset", 162, 24, "Reset all values back to their defaults.")
	chkMultipleMoves	= ui.createCheckbox("mm", "Combine Camera Moves", 162, 24, "Next move starts where the last move finished instead of reseting the render target.")
	chkMultipleMoves:updateProperties{ckecked = false}
	btnUndoLastCameraMove = ui.createButton("undoCM", "Undo Last Camera Move", 162, 24, "Sets Camera & Target Positions back to the end of the previous camera move.")
	btnUndoLastCameraMove:updateProperties{ enable = false}
	lblCameraMoveNumber	= ui.createLabel("Last Camera Move: ",162, 24)
	

-- Manage settings children

	managesettings_children = 
    	{
	defaultLoadButton		,	defaultSaveButton 	,	defaultResetButton,
	chkMultipleMoves		,	lblCameraMoveNumber,	btnUndoLastCameraMove 	
    	}

	grpSavedSettings	= ui.createGroup("grpSavedSettings", managesettings_children, true, 2, 3, nil, nil, "Manage Settings", { 5 }, nil, false)

	lblPadding		= ui.createLabel("",0,0)


-- Hidden Settings




-- Camera Position

	lblCameraOrbitLeftRight	= ui.createLabel("Orbit Left/Right")
	sldCameraOrbitLeftRight	= ui.createSlider("cleftright", 0, -360 , 360, 1, 400, 20)

	lblCameraOrbitUpDown	= ui.createLabel("Orbit Up/Down")
	sldCameraOrbitUpDown	= ui.createSlider("cupdown", 0, -90 , 90, 1, 400, 20)

	lblCameraPanLeftRight	= ui.createLabel("Pan Left/Right")
	sldCameraPanLeftRight  	= ui.createSlider("cleftright", 0, -1000, 1000, 1, 400, 20)

	lblCameraPanUpDown	= ui.createLabel("Pan Up/Down")
	sldCameraPanUpDown    	= ui.createSlider("cupdown", 0, -1000 , 1000, 1, 400, 20)

	lblCameraFowardBack   	= ui.createLabel("Foward/Back")
	sldCameraFowardBack  	= ui.createSlider("cfowardback", 0, -1000 , 1000, 01, 400, 20)


-- Camera Exposure for motion blur

	lblMotionBlurExposure   = ui.createLabel("Motion Blur")
	sldMotionBlurExposure  	= ui.createSlider("shutter", 0, 0, 1, 0.001, 400, 20)


-- Camera Direction

	lblStartAngleOffset		= ui.createLabel("Start Angle Offset")
	sldStartAngleOffset   	= ui.createSlider("offset", 0  , -180 , 180, 1, 400, 20)

	lblTargetUpDown		= ui.createLabel("Tilt Up/Down")
	sldTargetUpDown    	    = ui.createSlider("tupdown", 0  , -90 , 90, 1, 400, 20)

	lblTargetLeftRight		= ui.createLabel("Rotate Left/Right")
	sldTargetLeftRight    	= ui.createSlider("tleftright", 0  , -360 , 360, 1, 400, 20)

	lblCameraRoll		= ui.createLabel("Roll Left/Right")
	sldCameraRoll    	    	= ui.createSlider("croll", 0  , -90 , 90, 1, 400, 20)


-- Camera Settings

	lblFieldOfView  	    	= ui.createLabel("End Field Of View")
	sldFieldOfView    	    	= ui.createSlider("fov", 45  , 0 , 180, 5, 400, 20)

	lblNearClipDepth  	    	= ui.createLabel("End Near Clip Depth")
	sldNearClipDepth		= ui.createSlider("ncd", 0  , 0 , 1000, 10, 303, 20)
	chkInvert			= ui.createCheckbox("invert", "Invert", 100,18, "Reverses Direction of the animated Near Clip Plane.")

	lblDistanceToTarget	    	= ui.createLabel("Target Offset")
	targetSlider    		= ui.createSlider("target", 0 , -1000, 1000, 1, 400, 20)


-- Solar Settings

	lblSolarStartHour    		= ui.createLabel("Start Hour")
	lblSolarEndHour     		= ui.createLabel("End Hour")
	sldSolarStartHour   		= ui.createSlider("starthour", 7  , 0 , 24, 0.25, 400, 20)
	sldSolarEndHour		= ui.createSlider("endhour", 7  , 0 , 24, 0.25, 400, 20)


-- Preview settings

	lblPreview	= ui.createLabel("Samples/Pixel", 100, 20)
	btnPreview	= ui.createButton("previewrun", "Run", 80, 20, "Render walkthrough without saving frames.")
	sldPreview	= ui.createSlider("previewsamples", 1, 1, 100, 1, 317, 20)


-- Overall Animation Settings

	lblDuration  		= ui.createLabel("Duration")
	lblFrameRate 		= ui.createLabel("Frame Rate")
	lblFrames     		= ui.createLabel("Frames")
	lblSamples   		= ui.createLabel("Samples/Pixel")

	sldSamples  		= ui.createSlider("samples", 50, 1 , 16000, 1, 400, 20)
	sldDuration  		= ui.createSlider("duration", 5 , 1 , 3600  , 1, 400, 20)
	sldFrameRate		= ui.createSlider("rate", 25 , 10, 120   , 1, 400, 20)
	sldNumberOfFrames     	= ui.createSlider("frames", 250, 10, 432000, 1, 400, 20)


-- Create a buttons to show a file browser

	btnOutputFrames 		= ui.createButton("outputF", "Frames...", 80, 20, "Provide a seed file name for the frame sequence")
	btnOutputPositions		= ui.createButton("outputP", "Positions...", 80, 20, "NOT YET IMPLEMENTED. Provide a playback file name for the accumulated 					sequence of camera and target positions")


-- Create an editor that will show the chosen file path

	fileEditorFrames = octane.gui.create
	{
    		type   	= octane.gui.componentType.TEXT_EDITOR	,
    		text   	= ""					,
   		x       	= 20					,
    		width   	= 400					,
    		height  	= 20					,
    		enable  	= false					,    
	}


-- Create an editor that will show the chosen file path

	fileEditorPositions = octane.gui.create
	{
    		type   	= octane.gui.componentType.TEXT_EDITOR	,
    		text   	= ""					,
   		x       	= 20					,
    		width   	= 400					,
    		height  	= 20					,
    		enable  	= false					,    
	}


-- Group controls to facilitate form layout.
-- Solar path group children

	solarpath_children = 
    	{
	lblSolarStartHour		,	sldSolarStartHour	,
	lblSolarEndHour		,	sldSolarEndHour	,
    	}


-- Camera Position group children

	cameraposition_children = 
    	{
		lblCameraOrbitLeftRight	, 	sldCameraOrbitLeftRight	,
        		lblCameraOrbitUpDown       	, 	sldCameraOrbitUpDown    	,
        		lblCameraFowardBack      	, 	sldCameraFowardBack   	,
        		lblCameraPanLeftRight       	, 	sldCameraPanLeftRight   	,
        		lblCameraPanUpDown      	, 	sldCameraPanUpDown    	,
        		lblMotionBlurExposure       	,	sldMotionBlurExposure 	,
    	}


-- Camera Direction group children

	target_children = 
    	{
		lblStartAngleOffset 		,	sldStartAngleOffset	,
       		lblTargetLeftRight		, 	sldTargetLeftRight   	,
		lblTargetUpDown		, 	sldTargetUpDown    ,
		lblCameraRoll		,	sldCameraRoll  	,
  	    	
    	}


-- Initial Camera Settings group children

	lblInitialCameraSettings	= ui.createLabel("Initial Values",92,20)
	lblInitialDistanceToTarget	= ui.createLabel("Distance to target:",163,20)
	lblInitialFieldOfView		= ui.createLabel("Field of view:",115,20)
	lblInitialNearClip		= ui.createLabel("Near clip depth:",105,20)

	initialcamerasettings_children = 
	{
		lblInitialCameraSettings,lblInitialDistanceToTarget,	lblInitialFieldOfView	,lblInitialNearClip,	
	}

	grpInitialCameraSettings	= ui.createGroup("grpInitialCameraSettings", initialcamerasettings_children, false, 1, 4, nil, nil, "Initial Camera Settings", { 5 }, nil, false)


-- New Camera Settings 1 group children

	newcamerasettings1_children = 
    	{
		lblDistanceToTarget	,	targetSlider     	,
		lblFieldOfView 	,	sldFieldOfView 	,
       		--lblNearClipDepth	,	sldNearClipDepth   	,

    	}

	grpNewCameraSettings1	= ui.createGroup("grpNCS1", newcamerasettings1_children, false, 2, 2, nil, nil, "New Camera Settings", { 2 }, nil)


-- New Camera Settings 2 group children

	newcamerasettings2_children = 
    	{

       		lblNearClipDepth	,	sldNearClipDepth   	,chkInvert,

    	}

	grpNewCameraSettings2	= ui.createGroup("grpNCS2", newcamerasettings2_children, false, 1, 3, nil, nil, "New Camera Settings", { 2 }, nil)



-- Camera Settings group children

	CameraSettings_children = 
    	{
		grpInitialCameraSettings,
		grpNewCameraSettings1,
		grpNewCameraSettings2,
    	}


-- Animation group children

	animation_children = 
    	{
        		lblDuration      		,	sldDuration  	,
        		lblFrameRate    		,	sldFrameRate	,
        		lblFrames         		,	sldNumberOfFrames,
        		lblSamples       		,	sldSamples    	,
    	}


	output_children =
    	{
        		btnOutputFrames 		,	fileEditorFrames	,
        		btnOutputPositions 		,	fileEditorPositions	,
    	}


-- Create Groups
	
	grpCameraPosition		= ui.createGroup("cameraposition_group", cameraposition_children, true, 6, 2, nil, nil, "Camera Motion", { 2 }, { 5 })
	grpTargetMovement 	= ui.createGroup("target_group", target_children, true, 4, 2, nil, nil, "Camera Direction", { 2 }, { 5 })
	grpCameraSettings   	= ui.createGroup("camerasettings_group", CameraSettings_children, true, 3, 1, nil, nil, "Camera Settings", { 0 }, { 0})

	grpSolarPath 		= ui.createGroup("solarpath_group", solarpath_children, true, 2, 2, nil, nil, "Solar Settings", { 2 }, { 5 })
	grpPreview 		= ui.createGroup("previewgrp", {lblPreview, sldPreview,btnPreview, }, true, 1, 3, nil, nil, "Preview",  { 2 }, { 5 })
	grpAnimation 		= ui.createGroup("animation_group", animation_children, true, 4, 2, nil, nil, "Walkthrough", { 2 }, { 5 })


-- for layouting the button and the editor we use a group
	grpImageFileOutput 	= ui.createGroup("output_group", output_children, true, 2, 2, nil, nil, "Output Locations", { 2 }, { 5 })


-- Panel Stack for grpAnimation & grpImageFileOutput (not used)

	local panelStack = octane.gui.create
	{
   	type     = octane.gui.componentType.PANEL_STACK,
    	children =
    	{ 
		grpAnimation,
		grpImageFileOutput, 

    	},
    	open     = { false, false },                     	-- component open or closed
    	captions = { "Walkthrough", "Output Locations" }	-- captions to appear above the children
	}


-- Target drop down

	renderTargetDropDown = ui.createDrop_down("rendertarget", nil, 510, 20, nil)
	rendergrpTargetMovement = ui.createGroup("rendergrpTargetMovement", { renderTargetDropDown }, true, 1, 1, nil, nil, "Render Target", { 5 }, nil, true)


-- Progress bar 

	lblStartTime  		= ui.createLabel("Started at:", 162, 10)
	lblEndTime		= ui.createLabel("Completed at:", 162, 10)
	lblElapsedTime		= ui.createLabel("Elapsed Time:", 162, 10)
	lblPadding3		= ui.createLabel(" ")
	lblPadding4		= ui.createLabel(" ")

	progressBar = octane.gui.create
	{
    		type   = octane.gui.componentType.PROGRESS_BAR,
    		text   = "render progress",
    		width  = grpImageFileOutput:getProperties().width * 0.96, -- as wide as the group above
    		--width  = grpImageFileOutput:getProperties().width, -- as wide as the group above
    		height = 20,
	}


-- For layouting the progress bar

	grpProgressbar = ui.createGroup("progress", { progressBar }, false, 1, 1, nil, nil, "", { 1 }, nil, true)
	grpProgressbar2 = ui.createGroup("progress2", { lblStartTime,lblEndTime,lblElapsedTime}, false, 1, 3, nil, nil, "", { 1 }, nil, false)


-- Render Start, Stop & Exit buttons

	renderButton		= ui.createButton("start", "Output Current", 120, 24, "Output the Current Camera Move as a sequence of frames, positions, or both ")
	btnPreviousRender	= ui.createButton("start", "Output Previous", 120, 24, "Output the Previous Camera Move as a sequence of frames, positions, or both ")
	stopButton		= ui.createButton("stop", "Stop", 120, 24, "Stop the render")
	exitButton		= ui.createButton("cancel", "Cancel", 120, 24, "Stop the script")
	grpRenderButtons	= ui.createGroup("button", { renderButton,btnPreviousRender, stopButton, exitButton}, false, 1, 4, nil, nil, "", { 5}, { 5})


-- Group that lays out the other groups

	layout_children = 
    	{ 
        	--rendergrpTargetMovement,
		--grpInitialConditions,
		--grpProgressbar2,

		grpSavedSettings,
		grpCameraPosition,
		grpTargetMovement,
		grpCameraSettings,
		grpSolarPath,
		grpPreview,
		grpAnimation,
		grpImageFileOutput, 
		grpProgressbar,
		grpRenderButtons,
   	 }

	layoutGrp = ui.createGroup("layout", layout_children, false, 10, 1, nil, nil, "", { 2 }, nil, true)